$!-----------------------------------------------------------------------------
$! WASD_FILE_DEV.COM
$!
$! If P1 is an integer between 2 and 15 sets up for that WASD environment.
$!
$! Logical name table may be deleted using (as appropriate)
$!
$!   DEASSIGN <table-name> /TABLE=LNM$<whichever>_DIRECTORY [/EXECUTIVE]
$!
$! as with
$!
$!   DEASSIGN WASD_TABLE /TABLE=LNM$SYSTEM_DIRECTORY [/EXECUTIVE]
$!   DEASSIGN WASD_TABLE /TABLE=LNM$PROCESS_DIRECTORY
$!
$! Copyright (C) 1996-2010 Mark G.Daniel
$! This program, comes with ABSOLUTELY NO WARRANTY.
$! This is free software, and you are welcome to redistribute it under the
$! conditions of the GNU GENERAL PUBLIC LICENSE, version 3, or later version.
$! http://www.gnu.org/licenses/gpl.txt
$!
$! VERSION HISTORY
$! ---------------
$! 15-OCT-2010  MGD  check LNM$PROCESS_DIRECTORY to preserve structure
$!                     changes prior to running this procedure
$! 11-JUL-2009  MGD  initial
$!-----------------------------------------------------------------------------
$!
$ if f$type(P1) .eqs. "INTEGER" .and. P1 .ge. 2
$ then
$    if P1 .gt. 15
$    then
$       write sys$output "%WASD_FILE_DEV-E-ENV, out-of-range"
$       exit %X10000014
$    endif
$    wasd_table = "WASD_TABLE_" + P1
$ else
$    wasd_table = "WASD_TABLE"
$ endif
$ if .not. f$trnlnm (wasd_table,"LNM$SYSTEM_DIRECTORY",0,"EXECUTIVE",,"TABLE")
$ then
$    write sys$output "%WASD_FILE_DEV-E-ENV, no such table"
$    exit %X10000014
$ endif
$ if f$trnlnm ("LNM$FILE_DEV","LNM$PROCESS_DIRECTORY") .nes. ""
$    then lnm_directory = "LNM$PROCESS_DIRECTORY"
$    else lnm_directory = "LNM$SYSTEM_DIRECTORY"
$ endif
$ index = 0
$ file_dev = ""
$ loop:
$    table = f$trnlnm ("LNM$FILE_DEV",lnm_directory,index)
$    if table .eqs. "" then goto loop_end
$    if table .nes. wasd_table
$    then
$       if file_dev .nes. "" then file_dev = file_dev + ","
$       file_dev = file_dev + table
$       if table .eqs. "LNM$JOB"
$       then
$           if file_dev .nes. "" then file_dev = file_dev + ","
$           file_dev = file_dev + wasd_table
$       endif
$    endif
$    index = index + 1
$    goto loop
$ loop_end:
$!
$ define /nolog /table=LNM$PROCESS_DIRECTORY LNM$FILE_DEV 'file_dev'
$!-----------------------------------------------------------------------------
