$!-----------------------------------------------------------------------------
$! UPDATE_CLEANUP.COM
$!
$! WASD VMS Web Services, Copyright (C) 1996-2017 Mark G.Daniel.
$! This package (all associated programs), comes with ABSOLUTELY NO WARRANTY.
$! This is free software, and you are welcome to redistribute it under the
$! conditions of the GNU GENERAL PUBLIC LICENSE, version 3, or later version.
$! http://www.gnu.org/licenses/gpl.txt
$!
$! Clean up files from previous versions that are no longer required,
$! plus any other general post-upgrade activities that can be automated.
$!
$! 26-JUN-2017  MGD  after v11.0
$! 06-JAN-2016  MGD  after v10.4
$! 08-DEC-2013  MGD  after v10.3
$! 08-SEP-2013  MGD  after v10.2
$! 26-JAN-2012  MGD  after v10.1
$! 05-SEP-2009  MGD  after v10.0
$! 09-SEP-2006  MGD  after v9.1
$! 04-DEC-2005  MGD  after a goof in the 9.1.2 kit
$! 09-JUL-2005  MGD  after v9.0
$! 22-OCT-2002  MGD  after v8.0
$! 07-JUN-2002  MGD  after v7.2
$! 20-MAY-2001  MGD  after v7.1
$! 23-JUL-2000  MGD  after v7.0
$! 20-MAY-2000  MGD  after v6.1
$! 31-OCT-1999  MGD  after v6.0
$! 05-MAY-1999  MGD  after v5.3
$! 01-NOV-1998  MGD  after v5.2
$! 27-JUN-1998  MGD  after v5.0
$! 16-MAR-1998  MGD  initial
$!-----------------------------------------------------------------------------
$ set noon
$ arch_name = f$edit(f$getsyi("arch_name"),"upcase") 
$ if arch_name .eqs. "ALPHA" then arch_name = "AXP"
$ delete = "delete"
$!
$ if f$trnlnm("INSTALL$DBUG") .nes. "" then set verify
$!
$ if f$environment("depth") .eq. 1 then write sys$output ""
$!
$ TYPE SYS$INPUT
      *****************************************************************
      *   IGNORE ANY WARNINGS ABOUT FILES OR DIRECTORIES NOT FOUND    *
      *  (It attempts to clean up after all known versions of WASD!)  *
      *****************************************************************

$ WAIT 00:00:10
$!
$! whatever to v5.0.0
$ DELETE WASD_ROOT:[000000]CHANGES.HTML;*
$ DELETE WASD_ROOT:[000000]UPGRADINGBEWARE.HTML;*
$ DELETE WASD_ROOT:[000000]HFRDTOWASD.HTML;*
$ DELETE WASD_ROOT:[000000]ADMIN.GIF;*
$ DELETE WASD_ROOT:[000000]EDIT.GIF;*
$ DELETE WASD_ROOT:[000000]UPDATE.GIF;*
$ DELETE WASD_ROOT:[RUNTIME.CONAN]SPACER.GIF;*
$ DELETE WASD_ROOT:[DOC]DECUS95_WWW_INTRO.PS;*
$!
$! v5.0.0 to v5.1.0
$ DELETE WASD_ROOT:[000000]AFTERUPDATE.COM;*
$ DELETE WASD_ROOT:[000000]FREEWARE_DEMO.TXT;*
$ DELETE WASD_ROOT:[000000]FREEWARE_README.TXT;*
$ DELETE WASD_ROOT:[$_READ_1ST]READ1ST_0600.HTML;*
$ DELETE WASD_ROOT:[$_READ_1ST]READ1ST_0700.HTML;*
$ DELETE WASD_ROOT:[$_READ_1ST]READ1ST_0800.HTML;*
$ DELETE WASD_ROOT:[EXAMPLE]STARTUP_OSU.COM;*
$ DELETE WASD_ROOT:[RUNTIME.CONAN]CONAN.GIF;*
$ DELETE WASD_ROOT:[RUNTIME.DBIV]DBIV.GIF;*
$ DELETE WASD_ROOT:[RUNTIME.HDISK]HDISK.GIF;*
$ DELETE WASD_ROOT:[RUNTIME.HWP]HWP.GIF;*
$ DELETE WASD_ROOT:[RUNTIME.HYPERSHELF]CLOSE.GIF;*
$ DELETE WASD_ROOT:[RUNTIME.HYPERSHELF]HELP.GIF;*
$ DELETE WASD_ROOT:[RUNTIME.HYPERSHELF]HR.GIF;*
$ DELETE WASD_ROOT:[RUNTIME.HYPERSHELF]HYPERSHELF.GIF;*
$ DELETE WASD_ROOT:[RUNTIME.HYPERREADER]*.GIF;*
$ DELETE WASD_ROOT:[RUNTIME.HYPERSPI]HYPERSPI.GIF;*
$ DELETE WASD_ROOT:[SRC]PRUNE.COM;*
$ DELETE WASD_ROOT:[SRC]RELINK_ALL.COM;*
$ DELETE WASD_ROOT:[SRC.EXTRACT...]EXTRACTFILE.*;*
$ DELETE WASD_ROOT:[SRC.EXTRACT...]COPYTEXT.*;*
$ DELETE WASD_ROOT:[SRC.HYPERSPI]HYPERSPI.GIF;*
$ DELETE WASD_ROOT:[SRC.HYPERSPI]HYPERSPI_EXAMPLE.JPG;*
$ DELETE WASD_ROOT:[SRC.QUERY...]COPYTEXT.*;*
$ DELETE WASD_ROOT:[SRC.QUERY...]SEARCHFILES.*;*
$ DELETE WASD_ROOT:[SRC.QUERY...]SEARCHHTMLFILE.*;*
$ DELETE WASD_ROOT:[SRC.QUERY...]SEARCHTEXTFILE.*;*
$!(reinstated with 7.2 release)
$! DELETE WASD_ROOT:[SRC.MISC]BUILD_CALENDAR.COM;*
$ DELETE WASD_ROOT:[SRC.MISC]BUILD_CHARSET.COM;*
$! DELETE WASD_ROOT:[SRC.MISC]BUILD_CHKACC.COM;*
$ DELETE WASD_ROOT:[SRC.MISC]BUILD_COLORS.COM;*
$! DELETE WASD_ROOT:[SRC.MISC]BUILD_GLIST.COM;*
$ DELETE WASD_ROOT:[SRC.MISC]BUILD_HDISK.COM;*
$!
$! v5.1.0 to v5.3.0
$ DELETE WASD_ROOT:[SRC.EXTRACT...]*.*;*
$ DELETE WASD_ROOT:[SRC.EXTRACT...]*.*;*
$ DELETE WASD_ROOT:[SRC]EXTRACT.DIR;*
$ DELETE WASD_ROOT:[SRC.HYPERSHELF...]*.*;*
$ DELETE WASD_ROOT:[SRC.HYPERSHELF...]*.*;*
$ DELETE WASD_ROOT:[SRC]HYPERSHELF.DIR;*
$ DELETE WASD_ROOT:[SRC.QUERY]ABOUTQUERY.HTML;*
$!
$! v5.3.0 to v6.0.0
$ DELETE WASD_ROOT:[000000]HT_ROOT.DIR;*
$ DELETE WASD_ROOT:[$_READ_1ST]*.*;*
$ DELETE WASD_ROOT:[000000]$_READ_1ST.DIR;*
$ DELETE WASD_ROOT:[DOC.MENU_PRIMER]*.*;*
$ DELETE WASD_ROOT:[DOC]MENU_PRIMER.DIR;*
$ DELETE WASD_ROOT:[AACRT060]*.*;*
$ DELETE WASD_ROOT:[000000]AACRT060.DIR;*
$ DELETE WASD_ROOT:[DOC.HTD]SSLEAY.GIF;*
$ DELETE WASD_ROOT:[DOC.MISC]HFRDTOWASD.HTML;*
$!
$! v6.0.0 to v6.1.0
$ DELETE WASD_ROOT:[DOC.ENV]ENV.TXT;*
$ DELETE WASD_ROOT:[DOC.ENV]ENV.DECW$*;*
$ DELETE WASD_ROOT:[DOC.HTD]HTD.TXT;*
$ DELETE WASD_ROOT:[DOC.HTD]HTD.DECW$*;*
$ DELETE WASD_ROOT:[DOC.NAB]NAB.TXT;*
$ DELETE WASD_ROOT:[DOC.NAB]NAB.DECW$*;*
$ DELETE WASD_ROOT:[DOC.SDM2HTM]SDM2HTM.TXT;*
$ DELETE WASD_ROOT:[DOC.SDM2HTM]SDM2HTM.DECW$*;*
$ DELETE WASD_ROOT:[DOC.YAHMAIL]YAHMAIL.TXT;*
$ DELETE WASD_ROOT:[DOC.YAHMAIL]YAHMAIL.DECW$*;*
$ DELETE WASD_ROOT:[SRC.HTTPD...]*SSLEAY*.*;*
$ DELETE WASD_ROOT:[SRC.HTTPD...]*NETLIB*.*;*
$ DELETE WASD_ROOT:[SRC.MISC...]*NETLIB*.*;*
$ DELETE WASD_ROOT:[SRC.MISC]FETCH_*.OPT;*
$ DELETE WASD_ROOT:[SRC.UTILS...]*NETLIB*.*;*
$ DELETE WASD_ROOT:[SRC.UTILS]HTTPDMON_*.OPT;*
$ DELETE WASD_ROOT:[EXERCISE]LIBRARY.*;*
$ DELETE WASD_ROOT:[AXP...]*_NETLIB.EXE;*
$ DELETE WASD_ROOT:[VAX...]*_NETLIB.EXE;*
$!
$! whatever to v7.0.0
$ DELETE WASD_ROOT:[EXAMPLE]HTTPD$MSG_*.CONF;*
$ DELETE WASD_ROOT:[EXERCISE]WWWRKOUT.HTML;*
$ DELETE WASD_ROOT:[SCRIPT]DIRFILESPEC.COM;*
$ DELETE WASD_ROOT:[SCRIPT]CGIPLUS.PL;*
$ DELETE WASD_ROOT:[SCRIPT]CGIPLUSPERL.COM;*
$ DELETE WASD_ROOT:[SCRIPT]HELLOTHERE.PL;*
$ DELETE WASD_ROOT:[SRC.CONAN]CONANHELP.HTML;*
$!
$! whatever to v7.1.0
$ DELETE WASD_ROOT:[DOC.HTD]FORTIFY_ANIM3.GIF;*
$ DELETE WASD_ROOT:[DOC.MISC]*.GIF;*
$ DELETE WASD_ROOT:[EXERCISE]HELLOTHERE.PL;*
$ DELETE WASD_ROOT:[EXERCISE]PERF_*.*;* /EXCLUDE=PERF_*_AB*.*;*
$ DELETE WASD_ROOT:[EXERCISE]WWWRKOUT*.*;*,SPINNERET*.*;*
$ DELETE WASD_ROOT:[SRC.HTTPD]READ*.HTML;*
$ DELETE WASD_ROOT:[SRC.HYPERSPI]*.OPT;*
$ DELETE WASD_ROOT:[SRC.MISC]FETCH*.OPT;*
$!! DELETE WASD_ROOT:[SRC.OSU]CGILIB.*;*
$ DELETE WASD_ROOT:[SRC.UTILS]*.OPT;*
$!
$! whatever to v7.2.0
$ DELETE WASD_ROOT:[SRC.UTILS...]*SCRUNCH.*;*
$ DELETE WASD_ROOT:[AXP]SCRUNCH.EXE;*
$ DELETE WASD_ROOT:[VAX]SCRUNCH.EXE;*
$ DELETE WASD_ROOT:[SRC.SDM2HTM]*.OPT;*
$!
$! whatever to v8.0.0
$ DELETE WASD_ROOT:[DOC.NAB]*.*;*
$ DELETE WASD_ROOT:[DOC]NAB.DIR;*
$ DELETE WASD_ROOT:[DOC.SCRIPTING]SCRIPTING_JAVA.SDML;*
$ DELETE WASD_ROOT:[SRC.UTILS...]*WWWRKOUT.*;*
$ DELETE WASD_ROOT:[AXP]WWWRKOUT.EXE;*
$ DELETE WASD_ROOT:[VAX]WWWRKOUT.EXE;*
$!
$! whatever to v8.1.0
$ DELETE WASD_ROOT:[SCRIPT]CGI_PROCESS.COM;*
$ DELETE WASD_ROOT:[SRC.UTILS...]*STREAMLF.*;* /EXCLUDE=STREAMLF.COM
$ DELETE WASD_ROOT:[AXP]STREAMLF.EXE;*
$ DELETE WASD_ROOT:[VAX]STREAMLF.EXE;*
$ DELETE WASD_ROOT:[SRC.HPRINTS...]*.*;*
$ DELETE WASD_ROOT:[SRC.HPRINTS...]*.*;*
$ DELETE WASD_ROOT:[SRC]HPRINTS.DIR;*
$ DELETE WASD_ROOT:[SCRIPT]HPRINTS.COM;*
$ DELETE WASD_ROOT:[AXP]HPRINTS.EXE;*
$ DELETE WASD_ROOT:[VAX]HPRINTS.EXE;*
$!(this procedure was used in the v8.1 release candidate 1)
$ DELETE WASD_ROOT:[INSTALL]UPDATE_SSL.COM;*
$!
$! a goof in the v9.1.0 kit let all sorts of IA64 stuff to escape
$ if arch_name .nes. "IA64"
$ then
$    if f$search ("WASD_ROOT:[IA64]*.EXE") .eqs. ""
$    then
$       DELETE WASD_ROOT:[SRC.MISC.OBJ_IA64]*.OLB;*
$       DELETE WASD_ROOT:[SRC...]OBJ_IA64.DIR;*
$    endif
$ endif
$!
$! a goof in the v9.1.1/2 kit let some PHP stuff to escape
$ if f$search ("WASD_ROOT:[PHP]AXP.DIR") .nes. ""
$ then
$    if f$search ("WASD_ROOT:[PHP.AXP]*.*") .eqs. ""
$    then
$       DELETE WASD_ROOT:[PHP]AXP.DIR;*
$       DELETE WASD_ROOT:[000000]PHP.DIR;*
$       DELETE WASD_ROOT:[SRC.CGIPLUS]LRA0.COM;*
$    endif
$ endif
$!
$! whatever to v9.2.0
$ DELETE WASD_ROOT:[DOC.ENV]*.PS;*
$ DELETE WASD_ROOT:[DOC.HTD]*.PS;*
$ DELETE WASD_ROOT:[DOC.HTD]SSL128.GIF;*
$ DELETE WASD_ROOT:[DOC.SCRIPTING]*.PS;*
$ DELETE WASD_ROOT:[DOC.SDM2HTM]*.PS;*
$!
$! whatever to v10.0.0
$ DELETE WASD_ROOT:[DOC.HTD]*.*;*
$ DELETE WASD_ROOT:[DOC]HTD*.DIR;*
$ DELETE WASD_ROOT:[DOC.ENV]ENV.PDF;*
$ DELETE WASD_ROOT:[DOC.SCRIPTING]SCRIPTING.PDF;*
$ DELETE WASD_ROOT:[DOC.SDM2HTM]SDM2HTM.PDF;*
$ DELETE WASD_ROOT:[EXAMPLE]HTTPD$CONFIG.CONF;*
$ DELETE WASD_ROOT:[EXAMPLE]HTTPD$AUTH.CONF;*
$ DELETE WASD_ROOT:[EXAMPLE]HTTPD$MAP.CONF;*
$ DELETE WASD_ROOT:[EXAMPLE]HTTPD$MAP_DEMO.CONF;*
$ DELETE WASD_ROOT:[EXAMPLE]HTTPD$MSG.CONF;*
$!
$! whatever to v10.0.2
$ DELETE WASD_ROOT:[DOC.MISC]READ1ST.HTML;*
$!
$! whatever to v10.1.1
$ DELETE WASD_ROOT:[SRC.WEBSOCKET]*WS_PTD*.*;*
$!
$! whatever to v10.3.0
$ DELETE WASD_ROOT:[SRC.HTTPD]README.TXT;*
$!
$! whatever to v10.4.0
$ DELETE WASD_ROOT:[SRC.MISC]BUILD_ONE.COM;*
$ DELETE WASD_ROOT:[SRC.MISC...]*CALENDAR*.*;*
$ DELETE WASD_ROOT:[AXP-BIN]CALENDAR.EXE;*
$ DELETE WASD_ROOT:[IA64-BIN]CALENDAR.EXE;*
$ DELETE WASD_ROOT:[VAX-BIN]CALENDAR.EXE;*
$ DELETE WASD_ROOT:[SRC.MISC...]*CHARSET*.*;*
$ DELETE WASD_ROOT:[AXP-BIN]CHARSET.EXE;*
$ DELETE WASD_ROOT:[IA64-BIN]CHARSET.EXE;*
$ DELETE WASD_ROOT:[VAX-BIN]CHARSET.EXE;*
$ DELETE WASD_ROOT:[SRC.MISC...]*COLORS*.*;*
$ DELETE WASD_ROOT:[AXP-BIN]COLORS.EXE;*
$ DELETE WASD_ROOT:[IA64-BIN]COLORS.EXE;*
$ DELETE WASD_ROOT:[VAX-BIN]COLORS.EXE;*
$ DELETE WASD_ROOT:[SRC.MISC...]*GLIST*.*;*
$ DELETE WASD_ROOT:[AXP-BIN]GLIST.EXE;*
$ DELETE WASD_ROOT:[IA64-BIN]GLIST.EXE;*
$ DELETE WASD_ROOT:[VAX-BIN]GLIST.EXE;*
$ DELETE WASD_ROOT:[RUNTIME.HDISK]*.*;*
$ DELETE WASD_ROOT:[RUNTIME]HDISK.DIR;*
$ DELETE WASD_ROOT:[AXP-BIN]HDISK.EXE;*
$ DELETE WASD_ROOT:[IA64-BIN]HDISK.EXE;*
$ DELETE WASD_ROOT:[VAX-BIN]HDISK.EXE;*
$ DELETE WASD_ROOT:[SRC.GIFT...]*.*;*
$ DELETE WASD_ROOT:[SRC.GIFT...]*.*;*
$ DELETE WASD_ROOT:[SRC]GIFT.DIR;*
$!
$! whatever to v11.0.0
$ DELETE WASD_ROOT:[SRC.HTTPD...]ISMAP.*;*
$ DELETE WASD_ROOT:[SRC.HTTPD...]FILEDOT.*;*
$ DELETE WASD_ROOT:[SRC.HTTPD...]MENU.*;*
$ DELETE WASD_ROOT:[SRC.HTTPD...]TRACK.*;*
$ DELETE WASD_ROOT:[DOC.FEATURES]ACTIVITY.GIF;*,ADMIN.*;*,EDIT.GIF;*,-
HTTPDMON.GIF;*,UPDATE.GIF;*,WATCH.GIF;*,WATCHREPORT.GIF;*
$ DELETE WASD_ROOT:[EXERCISE...]ISMAP*.*;*
$ DELETE WASD_ROOT:[EXERCISE...]URL*.*;*
$!
$! no idea where these came from
$ DELETE WASD_ROOT:[DOC.SDM2HTM]WASD_SDM2HTM.PDF;*
$ DELETE WASD_ROOT:[SRC.UTILS]*.PNG;*
$!
$ WRITE SYS$OUTPUT ""
$!-----------------------------------------------------------------------------
