/*****************************************************************************/
/*
                                  Request.h
*/
/*****************************************************************************/

#ifndef REQUEST_H_LOADED
#define REQUEST_H_LOADED 1

#include "wasd.h"

/**********/
/* macros */
/**********/

#define REQUEST_STATE_CONNECTED  0x1
#define REQUEST_STATE_PERSIST    0x2
#define REQUEST_STATE_HEADER     0x3
#define REQUEST_STATE_PROCESSING 0x4
#define REQUEST_STATE_TIMEOUT    0x5
#define REQUEST_STATE_RUNDOWN    0x6
#define REQUEST_STATE_ENDING     0x7
#define REQUEST_STATE_SHUTDOWN   0x8
#define REQUEST_STATE_NOMORE     0x9

/***********************/
/* function prototypes */
/***********************/

void RequestAccept (NETIO_STRUCT*);
void RequestAlert (REQUEST_STRUCT*);
void RequestBegin (REQUEST_STRUCT*);
int RequestControlRunDown (int);
void RequestDiscardBody (REQUEST_STRUCT*);
void RequestDump ();
void RequestEnd (REQUEST_STRUCT*);
void RequestEnd2 (REQUEST_STRUCT*);
void RequestEnd3 (REQUEST_STRUCT*);
void RequestEnd4 (REQUEST_STRUCT*);
void RequestEnd5 (REQUEST_STRUCT*);
void RequestExecute (REQUEST_STRUCT*);
void RequestExecuteMappingError (REQUEST_STRUCT*);
void RequestExecutePostAuth1 (REQUEST_STRUCT*);
void RequestExecutePostAuth2 (REQUEST_STRUCT*);
void RequestExecutePostCache1 (REQUEST_STRUCT*);
void RequestExecutePostCache2 (REQUEST_STRUCT*);
void RequestExecutePostThrottle (REQUEST_STRUCT*);
BOOL RequestFields (REQUEST_STRUCT*, char*);
BOOL RequestProcessFields (REQUEST_STRUCT*);
void RequestFile (REQUEST_STRUCT*, REQUEST_AST, REQUEST_AST);
void RequestFileNoType (REQUEST_STRUCT*);
void RequestGblSecUpdate (REQUEST_STRUCT*);
void RequestGet (REQUEST_STRUCT*);
DICT_ENTRY_STRUCT* RequestDictHeader (REQUEST_STRUCT*);
void RequestHistory (REQUEST_STRUCT*);
void RequestHomePage (REQUEST_STRUCT*);
char* RequestState (REQUEST_STRUCT*);
int RequestHttpStatusCode (REQUEST_STRUCT*);
void RequestIoCancel (REQUEST_STRUCT*);
BOOL RequestIoInProgress (REQUEST_STRUCT*);
int RequestHttpStatusIndex (int);
void RequestParseDictionary (REQUEST_STRUCT*);
void RequestParseExecute (REQUEST_STRUCT*);
void RequestParseHeader (REQUEST_STRUCT*);
void RequestPersistentConnection (REQUEST_STRUCT*);
void RequestRedact (REQUEST_STRUCT*, char*, int, BOOL);
BOOL RequestRedactEnd (REQUEST_STRUCT*);
void RequestReport (REQUEST_STRUCT*);
BOOL RequestRunDown (REQUEST_STRUCT*);
void RequestScript (REQUEST_STRUCT*, char*, char*, char*);
void RequestShareBegin (REQUEST_STRUCT*);

/* redirect.c prototype */

int RedirectRequest (REQUEST_STRUCT*);

#endif /* REQUEST_H_LOADED */

/*****************************************************************************/
