/*****************************************************************************/
/*
                                 Support.h
*/
/*****************************************************************************/

#ifndef SUPPORT_H_LOADED
#define SUPPORT_H_LOADED 1

/* standard C header files */
#include <time.h>

/* VMS related header files */
#include <fab.h>
#include <nam.h>

/* application related header files */
#include "wasd.h"

/**********/
/* macros */
/**********/

/* the current size determined by the The Apache Group */
#define UNIQUE_ID_SIZE 19

/***********************/
/* function prototypes */
/***********************/

LIST_ENTRY* ListAddHead (LIST_HEAD*, LIST_ENTRY*, ulong);
LIST_ENTRY* ListAddTail (LIST_HEAD*, LIST_ENTRY*, ulong);
LIST_ENTRY* ListAddBefore (LIST_HEAD*, LIST_ENTRY*, LIST_ENTRY*, ulong);
LIST_ENTRY* ListRemove (LIST_HEAD*, LIST_ENTRY*);
LIST_ENTRY* ListRemoveTail (LIST_HEAD*);
LIST_ENTRY* ListRemoveHead (LIST_HEAD*);
ListDebug (LIST_HEAD*);

char* AverageDurationString (REQUEST_STRUCT*, ulong*, ulong);
int BytesPerSecond (ulong*, ulong*, ulong*);
char* ClientHostString (REQUEST_STRUCT*);
int CompareVmsTime64 (ulong*, ulong*);
int ConvertFromUtf8 (char*, int, char);
int ConvertToUtf8 (char*, int, int);
int ConvertUtf8ToEscape (char*, char*, int);
int CopyTextIntoHtml (char*, char*, int);
char* DayOfWeekName (ulong*);
char* DateTime (ulong*, int);
DebugTrace();
char* DigitDayTime (ulong*);
char* DurationString (REQUEST_STRUCT*, ulong*);
float FloatDeltaTime (ulong*);
int FormatProtection (ushort, char*);
char* GenerateUniqueId (REQUEST_STRUCT*);
int GetVmsVersion ();
char* HtmlMetaInfo (REQUEST_STRUCT*, char*);
char* HttpStatusCodeText (int);
char* HttpStatusCodeExplanation (REQUEST_STRUCT*, int);
int HttpGmTime (char*, ulong*);
int HttpGmTimeString (char*, ulong*);
int HttpIsoTimeString (BOOL, char*, ulong*);
int HttpIfModifiedSince (REQUEST_STRUCT*, ulong*, int);
int HttpIfUnModifiedSince (REQUEST_STRUCT*, ulong*);
int ipow (int, int);
int MatchPerf ();
int PercentOf (ulong, ulong);
int QuadPercentOf (ulong*, ulong*);
#if !USE_INT64
BOOL QuadLtQuad (void*,void*);
#endif
int SetGlobalSymbol (char*, char*);
char* ServerSignature (REQUEST_STRUCT*, char*, int);
char* SysTrnLnm (char*);
int TimeAdjustGMT (BOOL, ulong*);
void TimeSansYear (ulong*, char*);
int TimeSetGMT ();
int TimeVmsToUnix (ulong*, struct tm*);
int ThisLongAgo (ulong*, char*);
char* UserAtClient (REQUEST_STRUCT *rqptr);
int VmsToHttpStatus (int);
char* v10orPrev10 (char*, int);

#endif /* SUPPORT_H_LOADED */

/*****************************************************************************/
