$!-----------------------------------------------------------------------------
$! BUILD_OSU.COM
$! Builds the OSU example scripts for both VAX and AXP systems (separately)
$!
$! P1 == BUILD or LINK
$! P1 == "DELETE" deletes those scripts from WASD_EXE ;^)
$!
$! 12-AUG-98  MGD  updated to v3.3a, added HTML_PREPROC.COM
$! 07-JAN-98  MGD  initial development
$!-----------------------------------------------------------------------------
$!
$ ON CONTROLY THEN EXIT 44
$!
$ WRITE SYS$OUTPUT ""
$ WRITE SYS$OUTPUT "Building ""OSU""" +-
                   " for ""''F$GETSYI("ARCH_NAME")'"" architecture"
$!
$ ARCH_NAME = F$EDIT(F$GETSYI("ARCH_NAME"),"UPCASE")
$ IF ARCH_NAME .EQS. "ALPHA" THEN ARCH_NAME = "AXP"
$!
$ IF F$SEARCH("OBJ_''ARCH_NAME'.DIR") .EQS. "" -
     THEN CREATE /DIR [.OBJ_'ARCH_NAME']
$ OBJECT_DIR = "[.OBJ_''ARCH_NAME']"
$!
$ DEFINES = "/DEFINE=(__VMS_VER=70000000,__CRTL_VER=70000000)"
$ IF F$EDIT(F$GETSYI("ARCH_NAME"),"UPCASE") .EQS. "VAX"
$ THEN
$    CC_OPTIONS = "/DECC /STANDARD=VAXC 'DEFINES' /OBJECT=''OBJECT_DIR'"
$ ELSE
$    CC_OPTIONS = "/STANDARD=VAXC 'DEFINES' /OBJECT=''OBJECT_DIR'"
$ ENDIF
$!
$ IF P1 .EQS. "" .OR. P1 .EQS. "BUILD" .OR. P1 .EQS. "COMPILE"
$ THEN
$    SET NOON
$    SET VERIFY
$!
$!   (support modules)
$    CC 'CC_OPTIONS' CGILIB.C
$    CC 'CC_OPTIONS' LBRIO.C
$    CC 'CC_OPTIONS' SCRIPTLIB.C
$!
$!   (various executables)
$    CC 'CC_OPTIONS' CGI_SYMBOLS.C
$    CC 'CC_OPTIONS' CGI-MAILTO.C
$    CC 'CC_OPTIONS' SET_DCL_ENV.C
$    CC 'CC_OPTIONS' TESTCGI.C
$    CC 'CC_OPTIONS' TESTFORM.C
$    CC 'CC_OPTIONS' TMAIL.C
$    CC 'CC_OPTIONS' VMSHELPGATE.C
$!
$!   (bookreader application)
$    CC 'CC_OPTIONS' WEBBOOK.C
$    CC 'CC_OPTIONS' BOOKFILE_SECTION.C
$    CC 'CC_OPTIONS' BOOKFILE_INDEX.C
$    CC 'CC_OPTIONS' BOOKFILE_TEXT.C
$    CC 'CC_OPTIONS' BOOKFILE_IO.C
$    CC 'CC_OPTIONS' BOOKFILE_FIGURE.C
$    CC 'CC_OPTIONS' WEBBOOK_SHELF.C
$!
$!   (HTML pre-processor)
$    CC 'CC_OPTIONS' ACCESS_DB.C
$    CC 'CC_OPTIONS' HTML_PREPROC.C
$!
$!   'F$VERIFY(0)
$    SET ON
$ ENDIF
$!
$ IF P1 .EQS. "" .OR. P1 .EQS. "BUILD" .OR. P1 .EQS. "LINK"
$ THEN
$    SET NOON
$    SET VERIFY
$    LINK /EXECUTABLE=WASD_EXE:CGI_SYMBOLS.EXE -
          'OBJECT_DIR'CGI_SYMBOLS, -
          'OBJECT_DIR'CGILIB , -
          'OBJECT_DIR'SCRIPTLIB
$    LINK /EXECUTABLE=WASD_EXE:CGI-MAILTO.EXE -
          'OBJECT_DIR'CGI-MAILTO, -
          'OBJECT_DIR'CGILIB , -
          'OBJECT_DIR'SCRIPTLIB
$    LINK /EXECUTABLE=WASD_EXE:HTML_PREPROC.EXE -
          'OBJECT_DIR'HTML_PREPROC, -
          'OBJECT_DIR'ACCESS_DB , -
          'OBJECT_DIR'SCRIPTLIB
$    LINK /EXECUTABLE=WASD_EXE:SET_DCL_ENV.EXE -
          'OBJECT_DIR'SET_DCL_ENV, -
          'OBJECT_DIR'CGILIB , -
          'OBJECT_DIR'SCRIPTLIB
$    COPY DCL_ENV_RM.COM WASD_EXE:
$    LINK /EXECUTABLE=WASD_EXE:OSU_TESTCGI.EXE -
          'OBJECT_DIR'TESTCGI, -
          'OBJECT_DIR'CGILIB , -
          'OBJECT_DIR'SCRIPTLIB
$    LINK /EXECUTABLE=WASD_EXE:OSU_TESTFORM.EXE -
          'OBJECT_DIR'TESTFORM, -
          'OBJECT_DIR'CGILIB , -
          'OBJECT_DIR'SCRIPTLIB
$    LINK /EXECUTABLE=WASD_EXE:TMAIL.EXE -
          'OBJECT_DIR'TMAIL, -
          'OBJECT_DIR'CGILIB , -
          'OBJECT_DIR'SCRIPTLIB
$    LINK /EXECUTABLE=WASD_EXE:VMSHELPGATE.EXE -
          'OBJECT_DIR'VMSHELPGATE, -
          'OBJECT_DIR'CGILIB , -
          'OBJECT_DIR'LBRIO, -
          'OBJECT_DIR'SCRIPTLIB
$    COPY HELPGATE.COM WASD_EXE:
$!
$    LINK /EXECUTABLE=WASD_EXE:WEBBOOK.EXE WEBBOOK_'ARCH_NAME'.OPT/OPTION
$!
$    COPY CGIWASD.COM WASD_EXE:
$    COPY HTML_PREPROC.COM WASD_EXE:
$    COPY WWWEXEC.COM WASD_EXE:
$!
$!   'F$VERIFY(0)
$    SET ON
$    PURGE /NOLOG 'OBJECT_DIR'
$ ENDIF
$!
$ IF P1 .EQS. "DELETE"
$ THEN
$    SET NOON
$    SET VERIFY
$    DELETE WASD_EXE:HTML_PREPROC.EXE;*
$    DELETE WASD_EXE:HTML_PREPROC.COM;*
$    DELETE WASD_EXE:SET_DCL_ENV.EXE;*
$    DELETE WASD_EXE:DCL_ENV_RM.COM;*
$    DELETE WASD_EXE:OSU_TESTCGI.EXE;*
$    DELETE WASD_EXE:OSU_TESTFORM.EXE;*
$    DELETE WASD_EXE:TMAIL.EXE;*
$    DELETE WASD_EXE:VMSHELPGATE.EXE;*
$    DELETE WASD_EXE:HELPGATE.COM;*
$    DELETE WASD_EXE:WEBBOOK.EXE;*
$!   'F$VERIFY(0)
$    SET ON
$ ENDIF
$!
$!-----------------------------------------------------------------------------
